package com.indigitall.indigitall_flutter_plugin.utils

import android.content.Context
import android.content.SharedPreferences

class FTPreferenceUtils {
    private val SHARED_PREFERENCES_NAME = "IndigitallFlutterPreferences"
    private val SHARED_PREFERENCES_PUSH_STRING =
        "$SHARED_PREFERENCES_NAME.getPushString"


    private fun savePreferences(context: Context, param: Any, key: String): Boolean {
        val pref = context.getSharedPreferences(SHARED_PREFERENCES_NAME, Context.MODE_PRIVATE)
        var editor: SharedPreferences.Editor? = null
        if (pref != null) editor = pref.edit()
        if (editor != null) {
            if (param is String) {
                return editor.putString(key, param).commit()
            } else if (param is Boolean) {
                return editor.putBoolean(key, param).commit()
            }
        }
        return false
    }

    private fun getSharedPreferencesString(context: Context?, key: String): String? {
        if (context != null) {
            val prefs = context.getSharedPreferences(SHARED_PREFERENCES_NAME, Context.MODE_PRIVATE)
            if (prefs != null) return prefs.getString(key, null)
        }
        return null
    }

    private fun getSharedPreferencesBoolean(context: Context?, key: String): Boolean? {
        if (context != null) {
            val prefs = context.getSharedPreferences(SHARED_PREFERENCES_NAME, Context.MODE_PRIVATE)
            if (prefs != null) return prefs.getBoolean(key, false)
        }
        return null
    }

    fun getPushString(context: Context?): String? {
        return getSharedPreferencesString(context, SHARED_PREFERENCES_PUSH_STRING)
    }

    fun setPushString(context: Context, value: String) {
        savePreferences(context, value, SHARED_PREFERENCES_PUSH_STRING)
    }

}