import 'dart:convert';

class ExternalApp {
  /// String field name id
  static const String JSON_ID = "id";

  /// String field name name
  static const String JSON_NAME = "name";

  /// String field name android code
  static const String JSON_ANDROID_CODE = "androidCode";

  /// id of external app
  int? id;

  /// name of externall app
  String? name;

  /// android code of app
  String? androidCode;

  ExternalApp(int? id, String? name, String? androidCode) {
    this.id = id;
    this.name = name;
    this.androidCode = androidCode;
  }

  ExternalApp.fromMap(Map? map) {
    map?.forEach((key, value) {
      switch (key) {
        case JSON_ID:
          id = int.parse(value.toString());
          break;
        case JSON_ANDROID_CODE:
          name = value.toString();
          break;
        case JSON_ANDROID_CODE:
          androidCode = value.toString();
          break;
        case JSON_NAME:
          name = value.toString();
          break;
      }
    });
  }

  static List<ExternalApp> createArray(String externalApp) {
    List<ExternalApp> externalApps = [];
    try {
      Map list = json.decode(externalApp);
      for (int i = 0; i < list.length; i++) {
        ExternalApp? app = new ExternalApp.fromMap(list[i]);
        externalApps.add(app);
      }
    } catch (exception) {
      print('external app getting error: ' + exception.toString());
    }

    return externalApps;
  }

  Map toMap() {
    Map map = Map();
    if (id != null) map[JSON_ID] = id;
    if (name != null) map[JSON_NAME] = name;
    if (androidCode != null) map[JSON_ANDROID_CODE] = androidCode;
    return map;
  }

  @override
  String toString() {
    return json.encode(toMap());
  }
}
